import pArms;

public class test1 {
    
    var matrix : int = 0;
    var rhs    : int = 0;
    var sol    : int = 0;
    var params : int = 0;
    var precon : int = 0;

    def initParams() {
        x10.io.Console.ERR.println("initParams : " + here);
        pArms.initialize();
        params = pArms.initParams();
    }

    def readSystem() {
	x10.io.Console.ERR.println("readSystem : " + here);
	var s : Rail[int](2) = pArms.readSystem(params);
	matrix = s(0);
	rhs = s(1);
    }

    def initSolution() {
        x10.io.Console.ERR.println("initSolution : " + here);
        sol = pArms.initSolution(matrix);
    }

    def finalize() {
        x10.io.Console.ERR.println("finalize : " + here);
        pArms.finalize();	
    }

    def resiNorm2() {
        x10.io.Console.ERR.println("resiNorm2 : " + here);
        return pArms.ResiNorm2(matrix, sol, rhs);
    }
    
    def solve() {
        x10.io.Console.ERR.println("solve : " + here);
        pArms.FGMRESD(matrix, precon, params, rhs, sol);
    }

    def createPrecond() {
        x10.io.Console.ERR.println("createPrecond : " + here);
        precon = pArms.createPrec(matrix, params);
    }

    public static def main(a: Rail[String]!) : void {

        var d : Dist(1) = Dist.makeUnique(Place.places);

        finish ateach(val (i): Point in d)
        {
            var t: test1! = new test1();
            var r:double;
            
            t.initParams();
            t.readSystem();
            t.initSolution();
            
            r = t.resiNorm2();
            x10.io.Console.ERR.println ("r (before) = " + r);
            
            t.createPrecond();
            t.solve();
            
            r = t.resiNorm2();
            x10.io.Console.ERR.println ("r (after) = " + r);
            
            t.finalize();
        }
    }
}

